diff --git a/distrib/utils/sysinst/savenewlabel.c b/distrib/utils/sysinst/savenewlabel.c
index a4467de..a711ded 100644
--- a/distrib/utils/sysinst/savenewlabel.c
+++ b/distrib/utils/sysinst/savenewlabel.c
@@ -55,14 +55,19 @@ __RCSID("$NetBSD: savenewlabel.c,v 1.12 2012/01/05 22:18:36 christos Exp $");
 
 int
 /*ARGSUSED*/
-savenewlabel(partinfo *lp, int nparts)
+savenewlabel(partinfo *lp, int nparts) /* TODO: what does lp there? */
 {
 	FILE *f;
 	char *f_name = malloc(STRSIZE * sizeof(char));
 	int i;
+	pm_devs_t *pm_i;
 
-	strlcpy(f_name, "/tmp/disktab.", STRSIZE);
-	strlcat(f_name, pm->bsddiskname, STRSIZE);
+	/* Check names collision */
+	for (pm_i = pm_head->next; partman_go && pm_i != NULL; pm_i = pm_i->next)
+		while (pm_i != pm && !strcmp(pm_i->bsddiskname, pm->bsddiskname))
+			pm->bsddiskname[strlen(pm->bsddiskname)-1] = rand() % ('z' - 'a') + 'a';
+
+	snprintf(f_name, STRSIZE, "/tmp/disktab.%s", pm->bsddiskname); // TODO: test
 
 	/*
 	  N.B. disklabels only support up to 2TB (32-bit field for sectors).
@@ -85,11 +90,11 @@ savenewlabel(partinfo *lp, int nparts)
 		exit (1);
 	}
 	scripting_fprintf(f, "%s|NetBSD installation generated:\\\n", pm->bsddiskname);
-	scripting_fprintf(f, "\t:dt=%s:ty=winchester:\\\n", disktype);
+	scripting_fprintf(f, "\t:dt=%s:ty=winchester:\\\n", pm->disktype);
 	scripting_fprintf(f, "\t:nc#%d:nt#%d:ns#%d:\\\n", pm->dlcyl, pm->dlhead, pm->dlsec);
 	scripting_fprintf(f, "\t:sc#%d:su#%" PRIu32 ":\\\n", pm->dlhead*pm->dlsec,
 	    (uint32_t)pm->dlsize);
-	scripting_fprintf(f, "\t:se#%d:%s\\\n", pm->sectorsize, doessf);
+	scripting_fprintf(f, "\t:se#%d:%s\\\n", pm->sectorsize, pm->doessf);
 	if ((size_t)nparts > __arraycount(pm->bsdlabel)) {
 		nparts = __arraycount(pm->bsdlabel);
 		if (logfp)
diff --git a/distrib/utils/sysinst/target.c b/distrib/utils/sysinst/target.c
index fb85a8c..6b8aeb7 100644
--- a/distrib/utils/sysinst/target.c
+++ b/distrib/utils/sysinst/target.c
@@ -159,7 +159,7 @@ target_already_root(void)
 		 */
 		return 1;
 
-	return is_active_rootpart(pm->diskdev, rootpart);
+	return is_active_rootpart(pm->diskdev, pm->rootpart);
 }
 
 
diff --git a/distrib/utils/sysinst/util.c b/distrib/utils/sysinst/util.c
index acfdfe9..d1df210 100644
--- a/distrib/utils/sysinst/util.c
+++ b/distrib/utils/sysinst/util.c
@@ -489,14 +489,6 @@ cd_has_sets(void)
 	return dir_exists_p(ext_dir_bin);
 }
 
-
-static int
-set_cd_select(menudesc *m, void *arg)
-{
-	*(int *)arg = m->cursel;
-	return 1;
-}
-
 /*
  * Check whether we can remove the boot media.
  * If it is not a local filesystem, return -1.
@@ -553,7 +545,7 @@ get_via_cdrom(void)
 			cd_menu[i].opt_name = cds[i].menu;
 			cd_menu[i].opt_menu = OPT_NOMENU;
 			cd_menu[i].opt_flags = OPT_EXIT;
-			cd_menu[i].opt_action = set_cd_select;
+			cd_menu[i].opt_action = set_menu_select;
 		}
 		/* create a menu offering available choices */
 		menu_cd = new_menu(MSG_Available_cds,
@@ -1632,4 +1624,11 @@ do_coloring (unsigned int fg, unsigned int bg) {
 	wrefresh(stdscr);
 	wrefresh(mainwin);
 	return;
-}
\ No newline at end of file
+}
+
+int
+set_menu_select(menudesc *m, void *arg)
+{
+	*(int *)arg = m->cursel;
+	return 1;
+}
